#include <stdarg.h>
#include <stdio.h>
#include <Frame.h>

ErrMsg::ErrMsg(short r,short c,const char *title,const char *m,...):
  TextWindow(msg,title)
{
  msg[0] = buf;
  msg[1] = 0;
  va_list p;
  va_start(p,m);
  vsprintf(buf,m,p);
  va_end(p);
  setpos(Point(r,c));
  setfocus(this);
}

void ErrMsg::key(int) { setfocus(0); }

ErrMsg::~ErrMsg() { }
