#include <des.h>

DES3::DES3(Desmode mode): DESBase(mode),des1(FAST),des2(FAST) { }

DES3::~DES3() { }

void DES3::setkey(const char *k,int klen) {
  char key[16];
  ldkey(key,16,k,klen);
  des1.setkey(key,8);
  des2.setkey(key + 8,8);
}

void DES3::encrypt(const char *ib,char *ob) {
  if (desmode == STANDARD) {
    iperm.encrypt(ib,ob);
    ib = ob;
  }
  des1.encrypt(ib,ob);
  des2.encrypt(ob,ob);
  des1.decrypt(ob,ob);
  if (desmode == STANDARD)
    iperm.decrypt(ob,ob);
}

void DES3::decrypt(const char *ib,char *ob) {
  if (desmode == STANDARD) {
    iperm.encrypt(ib,ob);
    ib = ob;
  }
  des1.encrypt(ib,ob);
  des2.decrypt(ob,ob);
  des1.decrypt(ob,ob);
  if (desmode == STANDARD)
    iperm.decrypt(ob,ob);
}
