#pragma implementation
#include <string.h>
#include "cipher.h"

void BlockCipher::ldkey(void *d,int dlen,const char *key,int keylen) {
  memset(d,0,dlen);
  int keypos = 0;
  char *dst = (char *)d;
  if (keylen < 0) keylen = strlen(key);
  for (int i = 0; i < dlen; ++i) {
    dst[i] ^= key[keypos++];
    if (keypos >= keylen)
      keypos = 0;
  }
}

