#include "Money.h"
#include <algorithm>

string Money::fmt(short fix,short w) const {
  string s;
  int sign = sgn();
  Money num = *this;
  if (sign < 0)
    num.mul(-1);
  if (w < fix)
    w = fix;
  do {
    s += '0' + num.div(10);
    if (fix && !--fix) {
      int i;
      for (i = 0; i < s.length() && s[i] == '0'; ++i)
	;
      s.erase(0,i);
      if (s.length())
	s += '.';
    }
  } while (--w > 0 || num.sgn());
  reverse(s.begin(),s.end());
  if (sign < 0)
    return "-" + s;
  return s;
}

string dec(Money i,int w) {
  return i.fmt(0,w);
}
