#pragma implementation "Prompt.h"
#include <Prompt.h>
#include <keyboard.h>

PromptWin::PromptWin(const string &m,const string &def) {
  name = m;
  txt.add(def);
}

int PromptWin::run() {
  frame->set(name.c_str());
  setphys(Rect(5,10,5,70));
  setfocus(this);
  return TextEditor::run();
}

void PromptWin::set(const string &s) {
  txt[0] = s;
}

PromptWin::~PromptWin() { }

string PromptWin::get() const {
  return txt[0];
}

void PromptWin::key(int ky) {
  switch (ky) {
  case KEY_ENTER: case KEY_F(1):
    setfocus(0);
    return;
  }
  TextEditor::key(ky);
}
